import abc
from typing import Generic, TypeVar

from rainbowadn.collection.comparison import *
from rainbowadn.core import *
from .binarymetadata import *
from .binaryprotocolized import *

__all__ = ('BinaryBalancing',)

TreeType = TypeVar('TreeType')
ActiveKeyType = TypeVar('ActiveKeyType')
MetaDataType = TypeVar('MetaDataType')


class BinaryBalancing(
    BinaryMetadata[ActiveKeyType, MetaDataType, TreeType],
    Generic[ActiveKeyType, MetaDataType, TreeType],
    abc.ABC
):
    def __init__(self, comparator_: Comparator[ActiveKeyType], empty_metadata: HashPoint[MetaDataType]):
        assert isinstance(comparator_, Comparator)
        assert isinstance(empty_metadata, HashPoint)
        self.comparator = comparator_
        super().__init__(empty_metadata)

    async def balance(
            self,
            protocolized: BinaryProtocolized[ActiveKeyType, MetaDataType, TreeType],
    ) -> TreeType:
        raise NotImplementedError
