from typing import Generic, TypeVar

from rainbowadn.core import *
from .binarycreation import *

__all__ = ('BinaryMetadata',)

TreeType = TypeVar('TreeType')
ActiveKeyType = TypeVar('ActiveKeyType')
MetaDataType = TypeVar('MetaDataType')


class BinaryMetadata(Generic[ActiveKeyType, MetaDataType, TreeType]):
    def __init__(self, empty_metadata: HashPoint[MetaDataType]):
        assert isinstance(empty_metadata, HashPoint)
        self.empty_metadata = empty_metadata

    async def metadata(
            self,
            treel: TreeType,
            treer: TreeType,
            key: HashPoint[ActiveKeyType],
            creation: BinaryCreation[ActiveKeyType, MetaDataType, TreeType],
    ) -> HashPoint[MetaDataType]:
        raise NotImplementedError

    async def verify_metadata(
            self,
            treel: TreeType,
            treer: TreeType,
            key: HashPoint[ActiveKeyType],
            metadata: HashPoint[MetaDataType],
            creation: BinaryCreation[ActiveKeyType, MetaDataType, TreeType],
    ) -> bool:
        assert_eq(await self.metadata(treel, treer, key, creation), metadata)
        return True
