from .iatomic import *

__all__ = ('IByte',)


class IByte(IAtomic):
    def __init__(self, value: int):
        assert isinstance(value, int)
        assert value in range(256)
        self.value = value

    @classmethod
    def size(cls) -> int:
        return 1

    @classmethod
    def _from_bytes(cls, source: bytes) -> 'IByte':
        assert isinstance(source, bytes)
        [value] = source
        return IByte(value)

    def __bytes__(self):
        return bytes([self.value])

    def __str__(self):
        return f'{self.value:02x}'
