import abc
from typing import Any, Callable, Coroutine, Optional, TypeAlias, TypeVar

from rainbowadn.core import *

__all__ = ('Inlining',)

Inlined = TypeVar('Inlined')
_FTuple: TypeAlias = tuple[int, Callable[[bytes, HashResolver], HashPoint], int]
_HTuple: TypeAlias = tuple[int, Callable[[], Coroutine[Any, Any, bytes]]]


class Inlining(RainbowFactory[Inlined], abc.ABC):
    def size(self) -> Optional[int]:
        raise NotImplementedError

    @classmethod
    def factory_size(cls, factory: RainbowFactory) -> Optional[int]:
        assert isinstance(factory, RainbowFactory)
        if isinstance(factory, Inlining):
            return factory.size()
        else:
            return None
